Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management
Class MBeanInfo

    java.lang.Object
      javax.management.MBeanInfo

All Implemented Interfaces:
  Serializable, Cloneable

Direct Known Subclasses:
  ModelMBeanInfoSupport, OpenMBeanInfoSupport

    public class MBeanInfo

extends Object
implements Cloneable, Serializable

Describes the management interface exposed by an MBean; that is, the set of attributes and operations which are available for management operations. Instances of this class are immutable. Subclasses may be mutable but this is not recommended.

The contents of the `MBeanInfo` for a Dynamic MBean are determined by its `getMBeanInfo()` method. This includes Open MBeans and Model MBeans, which are kinds of Dynamic MBeans.

The contents of the `MBeanInfo` for a Standard MBean are determined by the MBean server as follows:

- `getClassName()` returns the Java class name of the MBean object;
- `getConstructors()` returns the list of all public constructors in that object;
- `getAttributes()` returns the list of all attributes whose existence is deduced from the presence in the MBean interface of a `getName`, `isName`, or `setName` method that conforms to the conventions for Standard MBeans;
- `getOperations()` returns the list of all methods in the MBean interface that do not represent attributes;
- `getNotifications()` returns an empty array if the MBean does not implement the `NotificationBroadcaster` interface, otherwise the result of calling `NotificationBroadcaster.getNotificationInfo()` on it.

The remaining details of the `MBeanInfo` for a Standard MBean are not specified. This includes the description of the `MBeanInfo` and of any contained constructors, attributes, operations, and notifications; and the names and descriptions of parameters to constructors and operations.

Since:
  1.5
See Also:
  Serialized Form

Constructor Summary
`MBeanInfo(String className, String description, MBeanAttributeInfo[] attributes, MBeanConstructorInfo[] constructors, MBeanOperationInfo[] operations, MBeanNotificationInfo[] notifications)` Constructs an `MBeanInfo`.

Method Summary
`Object` | `clone()` Returns a shallow clone of this instance.
`boolean` | `equals(Object o)` Compare this MBeanInfo to another.
`MBeanAttributeInfo[]` | `getAttributes()` Returns the list of attributes exposed for management.
`String` | `getClassName()` Returns the name of the Java class of the MBean described by this `MBeanInfo`.
`MBeanConstructorInfo[]` | `getConstructors()` Returns the list of the public constructors of the MBean.
`String` | `getDescription()` Returns a human readable description of the MBean.
`MBeanNotificationInfo[]` | `getNotifications()` Returns the list of the notifications emitted by the MBean.
`MBeanOperationInfo[]` | `getOperations()` Returns the list of operations of the MBean.
`int` | `hashCode()` Returns a hash code value for the object.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MBeanInfo

    public MBeanInfo(String className,
                     String description,
                     MBeanAttributeInfo[] attributes,
                     MBeanConstructorInfo[] constructors,
                     MBeanOperationInfo[] operations,
                     MBeanNotificationInfo[] notifications)
              throws IllegalArgumentException

  Constructs an `MBeanInfo`.

  Parameters:
    `className` - The name of the Java class of the MBean described by this `MBeanInfo`. This value may be any syntactically legal Java class name. It does not have to be a Java class known to the MBean server or to the MBean's ClassLoader. If it is a Java class known to the MBean's ClassLoader, it is recommended but not required that the class's public methods include those that would appear in a Standard MBean implementing the attributes and operations in this MBeanInfo.
    `description` - A human readable description of the MBean (optional).
    `attributes` - The list of exposed attributes of the MBean. This may be null with the same effect as a zero-length array.
    `constructors` - The list of public constructors of the MBean. This may be null with the same effect as a zero-length array.
    `operations` - The list of operations of the MBean. This may be null with the same effect as a zero-length array.
    `notifications` - The list of notifications emitted. This may be null with the same effect as a zero-length array.
  Throws:
    `IllegalArgumentException`

Method Detail

### clone

    public Object clone()

  Returns a shallow clone of this instance. The clone is obtained by simply calling `super.clone()`, thus calling the default native shallow cloning mechanism implemented by `Object.clone()`. No deeper cloning of any internal field is made.

  Since this class is immutable, the clone method is chiefly of interest to subclasses.

  Overrides:
    `clone` in class `Object`
  Returns:
    a clone of this instance.
  See Also:
    `Cloneable`

### getClassName

    public String getClassName()

  Returns the name of the Java class of the MBean described by this `MBeanInfo`.

  Returns:
    the class name.

### getDescription

    public String getDescription()

  Returns a human readable description of the MBean.

  Returns:
    the description.

### getAttributes

    public MBeanAttributeInfo[] getAttributes()

  Returns the list of attributes exposed for management. Each attribute is described by an `MBeanAttributeInfo` object. The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanAttributeInfo` objects but that each referenced `MBeanAttributeInfo` object is not copied.

  Returns:
    An array of `MBeanAttributeInfo` objects.

### getOperations

    public MBeanOperationInfo[] getOperations()

  Returns the list of operations of the MBean. Each operation is described by an `MBeanOperationInfo` object. The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanOperationInfo` objects but that each referenced `MBeanOperationInfo` object is not copied.

  Returns:
    An array of `MBeanOperationInfo` objects.

### getConstructors

    public MBeanConstructorInfo[] getConstructors()

  Returns the list of the public constructors of the MBean. Each constructor is described by an `MBeanConstructorInfo` object.

  The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanConstructorInfo` objects but that each referenced `MBeanConstructorInfo` object is not copied.

  The returned list is not necessarily exhaustive. That is, the MBean may have a public constructor that is not in the list. In this case, the MBean server can construct another instance of this MBean's class using that constructor, even though it is not listed here.

  Returns:
    An array of `MBeanConstructorInfo` objects.

### getNotifications

    public MBeanNotificationInfo[] getNotifications()

  Returns the list of the notifications emitted by the MBean. Each notification is described by an `MBeanNotificationInfo` object. The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanNotificationInfo` objects but that each referenced `MBeanNotificationInfo` object is not copied.

  Returns:
    An array of `MBeanNotificationInfo` objects.

### equals

    public boolean equals(Object o)

  Compare this MBeanInfo to another. Two MBeanInfo objects are equal iff they return equal values for `getClassName()` and for `getDescription()`, and the arrays returned by the two objects for `getAttributes()`, `getOperations()`, `getConstructors()`, and `getNotifications()` are pairwise equal. Here "equal" means `Object.equals(Object)`, not identity.

  If two MBeanInfo objects return the same values in one of their arrays but in a different order then they are not equal.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `o` - the object to compare to.
  Returns:
    true iff `o` is an MBeanInfo that is equal to this one according to the rules above.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Description copied from class: `Object`
  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.